Subject: bug#73131: 28.2; Yielded threads get killed on C-g

From: Andrea Corallo <[email-masked]>
Date: Mon, 09 Sep 2024 02:47:07 -0400

Swapneil Singh <[email-masked]> writes:

> When using the Emacs cooperative threading system in a new project, I
> noticed that calling C-g results in quitting the background thread I
> create, even when those threads are yielded.
>
> Sending this as a bug report per Eli Zaretskii's mention that it may not
> be expected behavior
> (https://www.reddit.com/r/emacs/comments/1fbkkii/comment/lm3boja/).
>
> Repro recipe:
> - emacs -Q
> - `C-x 3` and run `list-threads` in the new window, then return to the
> older window
> - `M-:` `(make-thread (lambda () (cl-loop while t do (progn
> (thread-yield) (sleep-for 30)))))` and wait for the new thread to yield to
> the main thread.
> - `C-g`. The new thread disappears from the `list-threads` window.
>
>
> Note: While I am admittedly on Windows, given this behavior is within the
> cooperative threads of the Emacs runtime (rather than actual Windows
> threads) I *really* doubt that has anything to do with it.

Data point: I might be doing something different but I can't reproduce
this here on emacs-29.4 nor on emacs30 on GNU/Linux.

  Andrea